您的位置:首页 > 产品设计 > UI/UE

[leetcode] 63. Unique Paths II 解题报告

2015-11-04 15:49 579 查看
题目链接:https://leetcode.com/problems/unique-paths-ii/

Follow up for "Unique Paths":

Now consider if some obstacles are added to the grids. How many unique paths would there be?

An obstacle and empty space is marked as
1
and
0
respectively
in the grid.

For example,

There is one obstacle in the middle of a 3x3 grid as illustrated below.
[
[0,0,0],
[0,1,0],
[0,0,0]
]


The total number of unique paths is
2
.

Note: m and n will be at most 100.

思路: 和上一个一样都是动态规划的题目,只是稍微有点不同,就是多了不可以走的格子,所以不可以走的地方就直接可以设为到这里的路径为0。另外需要注意的是初始化状态的时候第一行和第一列,只要出现一个1,那么接下来的都将为0,因为上一个是不可到达的,而到下一个又必须从他经过。时间复杂度为O(M*N),空间复杂度为O(M*N)。具体代码如下:

class Solution {
public:
int uniquePathsWithObstacles(vector<vector<int>>& obstacleGrid) {
if(obstacleGrid.size() ==0) return 0;
int m = obstacleGrid.size(), n = obstacleGrid[0].size();
vector<vector<int>> dp(m, vector<int>(n, 0));
for(int i=0; i<m && obstacleGrid[i][0] != 1; i++) dp[i][0] =1;
for(int i=0; i<n && obstacleGrid[0][i] != 1; i++) dp[0][i] =1;
for(int i = 1; i< m; i++)
for(int j = 1; j < n; j++)
dp[i][j] = obstacleGrid[i][j]==1?0:dp[i-1][j]+dp[i][j-1];
return dp[m-1][n-1];
}
};
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: